---
title: Worker
slug: Web/API/Worker
tags:
  - API
  - DOM
  - Interface
  - JavaScript
  - Reference
  - Web Workers
  - Worker
  - Workers
---
<div>{{APIRef("Web Workers API")}}</div>

<p><span class="seoSummary">The <strong><code>Worker</code></strong> interface of the <a href="/en-US/docs/Web/API/Web_Workers_API">Web Workers API</a> represents a background task that can be created via script, which can send messages back to its creator.</span> Creating a worker is done by calling the <code>Worker("path/to/worker/script")</code> constructor.</p>

<p>Workers may themselves spawn new workers, as long as those workers are hosted at the same <a href="/en-US/docs/Web/Security/Same-origin_policy">origin</a> as the parent page. (Note: <a href="https://bugs.webkit.org/show_bug.cgi?id=22723">nested workers are not yet implemented in WebKit</a>).</p>

<p><a href="/en-US/docs/Web/API/Web_Workers_API/Functions_and_classes_available_to_workers" title="Functions and classes available to Web Workers">Not all interfaces and functions are available</a> to scripts inside a <code>Worker</code>. Workers may use {{domxref("XMLHttpRequest")}} for network communication, but its <code>responseXML</code> and <code>channel</code> attributes are always <code>null</code>. (<code><a href="/en-US/docs/Web/API/Fetch_API">fetch</a></code> is also available, with no such restrictions.)</p>

<h2 id="Constructors">Constructors</h2>

<dl>
 <dt>{{domxref("Worker.Worker", "Worker()")}}</dt>
 <dd>Creates a dedicated web worker that executes the script at the specified URL. This also works for <a href="/en-US/docs/Web/API/Blob">Blob URLs</a>.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em>Inherits properties from its parent, {{domxref("EventTarget")}}, and implements properties from {{domxref("AbstractWorker")}}.</em></p>

<h3 id="Event_handlers">Event handlers</h3>

<dl>
 <dt>{{domxref("AbstractWorker.onerror")}}</dt>
 <dd>An {{ domxref("EventListener") }} called whenever an {{domxref("ErrorEvent")}} of type <code>error</code> bubbles through to the worker. This is inherited from {{domxref("AbstractWorker")}}.</dd>
 <dt>{{domxref("Worker.onmessage")}}</dt>
 <dd>An {{ domxref("EventListener") }} called whenever a {{domxref("MessageEvent")}} of type <code>message</code> bubbles through the worker — i.e. when a message is sent to the parent document from the worker via {{domxref("DedicatedWorkerGlobalScope.postMessage")}}. The message is stored in the event's {{domxref("MessageEvent.data", "data")}} property.</dd>
 <dt>{{domxref("Worker.onmessageerror")}}</dt>
 <dd>Is an {{domxref("EventHandler")}} representing the code to be called when the {{event("messageerror")}} event is raised.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>Inherits methods from its parent, {{domxref("EventTarget")}}, and implements methods from {{domxref("AbstractWorker")}}.</em></p>

<dl>
 <dt>{{domxref("Worker.postMessage()")}}</dt>
 <dd>Sends a message — consisting of any JavaScript object — to the worker's inner scope.</dd>
 <dt>{{domxref("Worker.terminate()")}}</dt>
 <dd>Immediately terminates the worker. This does not let worker finish its operations; it is halted at once. <code><a href="/en-US/docs/Web/API/ServiceWorker">ServiceWorker</a></code> instances do not support this method.</dd>
</dl>

<h2 id="Events">Events</h2>

<dl>
 <dt><code><a href="/en-US/docs/Web/API/Worker/message_event">message</a></code></dt>
 <dd>Fires when the worker's parent receives a message from that worker.<br>
 Also available via the <code><a href="/en-US/docs/Web/API/Worker/onmessage">onmessage</a></code> property.</dd>
 <dt><code><a href="/en-US/docs/Web/API/Worker/messageerror_event">messageerror</a></code></dt>
 <dd>Fires when a <code>Worker</code> object receives a message that can't be <a href="/en-US/docs/Web/API/Web_Workers_API/Structured_clone_algorithm">deserialized</a>.<br>
 Also available via the <code><a href="/en-US/docs/Web/API/Worker/onmessageerror">onmessageerror</a></code> property.</dd>
</dl>

<dl>
 <dt><code><a href="/en-US/docs/Web/API/Window/rejectionhandled_event">rejectionhandled</a></code></dt>
 <dd>Fires every time a {{jsxref("Promise")}} rejects, regardless of whether or not there is a handler to catch the rejection.<br>
 Also available through the <code><a href="/en-US/docs/Web/API/WindowEventHandlers/onrejectionhandled">onrejectionhandled</a></code> event handler property.</dd>
 <dt><code><a href="/en-US/docs/Web/API/Window/unhandledrejection_event">unhandledrejection</a></code></dt>
 <dd>Fires when a {{jsxref("Promise")}} rejects with no handler to catch the rejection.<br>
 Also available using the <code><a href="/en-US/docs/Web/API/WindowEventHandlers/onunhandledrejection">onunhandledrejection</a></code> event handler property.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>The following code snippet creates a {{domxref("Worker")}} object using the {{domxref("Worker.Worker", "Worker()")}} constructor, then uses the worker object:</p>

<pre class="brush: js notranslate">var myWorker = new Worker('/worker.js');
var first = document.querySelector('input#number1');
var second = document.querySelector('input#number2');

first.onchange = function() {
  myWorker.postMessage([first.value, second.value]);
  console.log('Message posted to worker');
}</pre>

<p>For a full example, see our<a class="external external-icon" href="https://github.com/mdn/simple-web-worker">Basic dedicated worker example</a> (<a class="external external-icon" href="https://mdn.github.io/simple-web-worker/">run dedicated worker</a>).</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "#worker", "Worker")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>Support varies for different types of workers. See each worker type's page for specifics.</p>

<p>{{Compat("api.Worker")}}</p>

<h3 id="Cross-origin_worker_error_behaviour">Cross-origin worker error behaviour</h3>

<p>In early versions of the spec, loading a cross-origin worker script threw a <code>SecurityError</code>. Nowadays, an {{event("error")}} event is thrown instead. Find out how to deal with this in <em><a href="https://www.fxsitecompat.com/en-CA/docs/2016/loading-cross-origin-worker-now-fires-error-event-instead-of-throwing-worker-in-sandboxed-iframe-no-longer-allowed/">Loading cross-origin worker now fires error event instead of throwing; worker in sandboxed iframe no longer allowed</a></em>.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a class="internal" href="/en-US/docs/Web/API/Web_Workers_API/Using_web_workers" title="en/Using DOM workers">Using Web Workers</a></li>
 <li><a href="/en-US/docs/Web/API/Web_Workers_API/Functions_and_classes_available_to_workers">Functions and classes available to Web Workers</a></li>
 <li>Other kind of workers: {{domxref("SharedWorker")}} and <a href="/en-US/docs/Web/API/Service_Worker_API">Service Worker</a>.</li>
</ul>
